﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    internal class MapsCollection
    {
        readonly Dictionary<string, MapWithSetBusesGeneric<DrawningObjectBus, AbstractMap>> _mapStorages;

        public List<string> Keys => _mapStorages.Keys.ToList();

        private readonly int _pictureWidth;

        private readonly int _pictureHeight;

        public MapsCollection(int pictureWidth, int pictureHeight)
        {
            _mapStorages = new Dictionary<string, MapWithSetBusesGeneric<DrawningObjectBus, AbstractMap>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }

        public void AddMap(string name, AbstractMap map)
        {
            if (Keys.Contains(name)) return;
            _mapStorages.Add(name, new MapWithSetBusesGeneric<DrawningObjectBus, AbstractMap>(_pictureWidth, _pictureHeight, map));
        }

        public void DelMap(string name)
        {
            _mapStorages.Remove(name);
        }

        public MapWithSetBusesGeneric<DrawningObjectBus, AbstractMap> this[string ind]
        {
            get
            {
                _mapStorages.TryGetValue(ind, out var result);
                return result;
            }
        }
    }
}
